using System;
using System.Collections;
using System.Collections.Specialized;
using System.Globalization;
using System.IO;
using System.Text;
using System.Web;
using System.Reflection;

namespace Ilungasoft.Framework.Web.Modules
{
    /// <summary>
    /// ϴ״̬
    /// </summary>
    public enum UploadState
    {
        /// <summary>
        /// ڽ
        /// </summary>
        ReceivingData,
        /// <summary>
        /// 
        /// </summary>
        Complete,
        /// <summary>
        /// ϴ.
        /// </summary>
        Error
    }

    /// <summary>
    /// ϴϢ
    /// </summary>
    public class Progress
    {
        long contentLength = 0;
        long bytesRead;
        DateTime start;
        string uploadId = "";
        UploadState state;

        public Progress(long contentLength, string uploadId)
        {
            this.contentLength = contentLength;
            start = DateTime.Now;
            this.uploadId = uploadId;
        }

        public void SetBytesRead(long bytesRead)
        {
            lock (this)
            {
                this.bytesRead = bytesRead;
            }
        }


        public void SetState(UploadState state)
        {
            lock (this)
            {
                this.state = state;
            }
        }

        /// <summary>
        /// ܴС
        /// </summary>
        public long ContentLength
        {
            get
            {
                return contentLength;
            }
        }

        /// <summary>
        /// ϴС
        /// </summary>
        public long BytesRead
        {
            get
            {
                return bytesRead;
            }
        }

        /// <summary>
        /// ϴ״̬
        /// </summary>
        public UploadState State
        {
            get
            {
                return state;
            }
        }

        /// <summary>
        /// ϴʼʱ
        /// </summary>
        public DateTime Start
        {
            get
            {
                return start;
            }
        }

        /// <summary>
        /// Ψһ־ǰϴUploadID
        /// </summary>
        string UploadId
        {
            get
            {
                return uploadId;
            }
        }
    }

    /// <summary>
    /// asp.netĬϵϴϽӳ
    /// </summary>
    /// <Author> (http://www.webuc.net)</Author>
    /// <Links>
    /// http://www.cnforums.net
    /// http://www.communtiyserver.cn
    /// http://blog.joycode.com
    /// </Links>
    public class UploadProgressModule : IHttpModule
    {
        public UploadProgressModule()
        {

        }

        public void Init(HttpApplication application)
        {
            application.BeginRequest += new EventHandler(this.Application_BeginRequest);
            application.EndRequest += new EventHandler(this.Application_EndRequest);
            application.Error += new EventHandler(this.Application_Error);
        }

        public void Dispose()
        {
        }

        private void Application_BeginRequest(Object sender, EventArgs e)
        {
            HttpApplication app = sender as HttpApplication;
            HttpWorkerRequest request = GetWorkerRequest(app.Context);
            Encoding encoding = app.Context.Request.ContentEncoding;

            int bytesRead = 0; // ѶݴС
            int read; // ǰȡĿĴС
            int count = 8192; // ֿС
            byte[] buffer; // ϴ
            string uploadId; // Ψһ־ǰϴID
            Progress progress; // ¼ǰϴĽϢ

            if (request != null)
            {
                //  HTTP ѱȡĲ֡
                //
                byte[] tempBuff = request.GetPreloadedEntityBody();

                // Ǹϴ
                //
                if (
                    tempBuff != null
                    && IsUploadRequest(app.Request)
                    )
                {
                    // ȡϴС
                    // 
                    long length = long.Parse(request.GetKnownRequestHeader(HttpWorkerRequest.HeaderContentLength));
                    // ǰϴIDΨһ־ǰϴ
                    // ôUploadIDͨҳȡǰϴĽ
                    //
                    uploadId = app.Context.Request.QueryString["UploadID"];

                    // ʼ¼ǰϴ״̬
                    //
                    progress = new Progress(length, uploadId);
                    progress.SetState(UploadState.ReceivingData);

                    buffer = new byte[length];
                    count = tempBuff.Length; // ֿС

                    // ϴݸƹȥ
                    //
                    Buffer.BlockCopy(tempBuff, 0, buffer, bytesRead, count);

                    // ʼ¼ϴС
                    //
                    bytesRead = tempBuff.Length;
                    progress.SetBytesRead(bytesRead);
                    SetProgress(uploadId, progress, app.Application);

                    // ѭֿȡֱݶȡ
                    //
                    while (request.IsClientConnected() &&
                        !request.IsEntireEntityBodyIsPreloaded() &&
                        bytesRead < length
                        )
                    {
                        // һССڷֿС·ֿ
                        //
                        if (bytesRead + count > length)
                        {
                            count = (int)(length - bytesRead);
                            tempBuff = new byte[count];
                        }

                        // ֿȡ
                        //
                        read = request.ReadEntityBody(tempBuff, count);

                        // Ѷݿ
                        //
                        Buffer.BlockCopy(tempBuff, 0, buffer, bytesRead, read);

                        // ¼ϴС
                        //
                        bytesRead += read;
                        progress.SetBytesRead(bytesRead);
                        SetProgress(uploadId, progress, app.Application);

                    }
                    if (
                        request.IsClientConnected() &&
                        !request.IsEntireEntityBodyIsPreloaded()
                        )
                    {

                        // ϴ
                        //
                        InjectTextParts(request, buffer);

                        // ʾϴѽ
                        //
                        progress.SetBytesRead(bytesRead);
                        progress.SetState(UploadState.Complete);
                        SetProgress(uploadId, progress, app.Application);

                    }
                }
            }
        }

        /// <summary>
        /// ƳϢ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Application_EndRequest(Object sender, EventArgs e)
        {
            HttpApplication app = sender as HttpApplication;

            if (IsUploadRequest(app.Request))
            {
                SetUploadState(app, UploadState.Complete);
                RemoveFrom(app);
            }

        }

        /// <summary>
        /// ýϢ״̬ΪError
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Application_Error(Object sender, EventArgs e)
        {
            HttpApplication app = sender as HttpApplication;

            if (IsUploadRequest(app.Request))
            {
                SetUploadState(app, UploadState.Error);
            }

        }

        /// <summary>
        /// õǰϴϢ״̬
        /// </summary>
        /// <param name="app"></param>
        /// <param name="state"></param>
        void SetUploadState(HttpApplication app, UploadState state)
        {
            string uploadId = app.Request.QueryString["UploadID"];
            if (uploadId != null && uploadId.Length > 0)
            {
                Progress progress = GetProgress(uploadId, app.Application);
                if (progress != null)
                {
                    progress.SetState(state);
                    SetProgress(uploadId, progress, app.Application);
                }
            }
        }

        /// <summary>
        /// õǰϴĽϢ
        /// UploadID¼Application
        /// </summary>
        /// <param name="uploadId"></param>
        /// <param name="progress"></param>
        /// <param name="application"></param>
        void SetProgress(string uploadId, Progress progress, HttpApplicationState application)
        {
            if (uploadId == null || uploadId == string.Empty || progress == null)
                return;
            application.Lock();
            application["OpenlabUpload_" + uploadId] = progress;
            application.UnLock();
        }

        /// <summary>
        /// ApplicationƳϢ
        /// </summary>
        /// <param name="app"></param>
        void RemoveFrom(HttpApplication app)
        {
            string uploadId = app.Request.QueryString["UploadID"];
            HttpApplicationState application = app.Application;
            if (uploadId != null && uploadId.Length > 0)
            {
                application.Remove("OpenlabUpload_" + uploadId);
            }
        }

        /// <summary>
        /// UploadIDȡϴϢ
        /// </summary>
        /// <param name="uploadId"></param>
        /// <param name="application"></param>
        /// <returns></returns>
        public static Progress GetProgress(string uploadId, HttpApplicationState application)
        {
            Progress progress = application["OpenlabUpload_" + uploadId] as Progress;
            return progress;
        }

        HttpWorkerRequest GetWorkerRequest(HttpContext context)
        {

            IServiceProvider provider = (IServiceProvider)HttpContext.Current;
            return (HttpWorkerRequest)provider.GetService(typeof(HttpWorkerRequest));
        }

        /// <summary>
        /// ϴ
        /// </summary>
        /// <param name="request"></param>
        /// <param name="textParts"></param>
        void InjectTextParts(HttpWorkerRequest request, byte[] textParts)
        {
            BindingFlags bindingFlags = BindingFlags.Instance | BindingFlags.NonPublic;

            Type type = request.GetType();

            while ((type != null) && (type.FullName != "System.Web.Hosting.ISAPIWorkerRequest"))
            {
                type = type.BaseType;
            }

            if (type != null)
            {
                type.GetField("_contentAvailLength", bindingFlags).SetValue(request, textParts.Length);
                type.GetField("_contentTotalLength", bindingFlags).SetValue(request, textParts.Length);
                type.GetField("_preloadedContent", bindingFlags).SetValue(request, textParts);
                type.GetField("_preloadedContentRead", bindingFlags).SetValue(request, true);
            }
        }

        private static bool StringStartsWithAnotherIgnoreCase(string s1, string s2)
        {
            return (string.Compare(s1, 0, s2, 0, s2.Length, true, CultureInfo.InvariantCulture) == 0);
        }

        /// <summary>
        /// ǷΪϴ
        /// жϵĸContentTypemultipart/form-data
        /// </summary>
        /// <param name="request"></param>
        /// <returns></returns>
        bool IsUploadRequest(HttpRequest request)
        {
            return StringStartsWithAnotherIgnoreCase(request.ContentType, "multipart/form-data");
        }
    }
}
